Please use the Apache issue tracking system for new NetBeans issues (https://issues.apache.org/jira/projects/NETBEANS0/issues) !!
Bug 186672 - Add ability to provide custom cell renderers and tooltip providers into Variable view
Add ability to provide custom cell renderers and tooltip providers into Varia...
Status: VERIFIED FIXED
Product: debugger
Classification: Unclassified
Component: Code
6.x
PC Linux
: P2 (vote)
: 7.0
Assigned To: Martin Entlicher
issues@debugger
69patch1
: API, API_REVIEW_FAST
Depends on: 185431 186225
Blocks: 187789
  Show dependency treegraph
 
Reported: 2010-05-25 14:30 UTC by Martin Entlicher
Modified: 2010-07-22 03:14 UTC (History)
3 users (show)

See Also:
Issue Type: ENHANCEMENT
:


Attachments
API change with implementation. (48.16 KB, patch)
2010-05-31 21:02 UTC, Martin Entlicher
Details | Diff
Transition of tooltips from cell renderer's component to the table's tooltip. No API change. This should have been in the swing already! (3.38 KB, patch)
2010-06-03 12:08 UTC, Martin Entlicher
Details | Diff
Test of the renderers, editors and tooltips taken from the model. (17.94 KB, patch)
2010-06-03 12:09 UTC, Martin Entlicher
Details | Diff

Note You need to log in before you can comment on or make changes to this bug.
Description Martin Entlicher 2010-05-25 14:30:17 UTC
Currently all variable values are rendered as String.
Java debugger provides variable ID or toString() value. TableModel can return cell value as an arbitrary object, but the class type needs to be identical for the whole column.

We should introduce some extension of TableModel that would provide custom cell renderer.
Comment 1 Martin Entlicher 2010-05-25 15:47:15 UTC
Unfortunately the cell renderer is currently hard-coded in org.openide.explorer.propertysheet.RendererFactory, which is used by PropertyPanel.
OutlineViewOutline is a private class and therefore we can not override getCellRenderer() method.
Comment 2 Martin Entlicher 2010-05-31 21:02:11 UTC
Created attachment 99688 [details]
API change with implementation.
Comment 3 Martin Entlicher 2010-05-31 21:03:28 UTC
Please review this API change that is necessary for JavaFX debugger.
Test for this change will follow shortly...
Comment 4 Martin Entlicher 2010-06-01 13:04:53 UTC
The implementation is on debugger_view_renderers branch:
http://hg.netbeans.org/main/rev/5c75009b0619
Comment 5 Martin Entlicher 2010-06-03 12:08:53 UTC
Created attachment 99783 [details]
Transition of tooltips from cell renderer's component to the table's tooltip. No API change. This should have been in the swing already!
Comment 6 Martin Entlicher 2010-06-03 12:09:56 UTC
Created attachment 99784 [details]
Test of the renderers, editors and tooltips taken from the model.
Comment 7 Martin Entlicher 2010-06-03 12:26:26 UTC
Further changes pushed to debugger_view_renderers branch:

changeset:   172407:ec69211b150a - Use the column cell renderer even for the tree
                                   column, if defined.
http://hg.netbeans.org/main/rev/ec69211b150a

changeset:   172409:006ede593c0b - Convert the tooltips
http://hg.netbeans.org/main/rev/006ede593c0b

changeset:   172408:33e00165e1f4, 172410:b0028a1d8f90 - Tests
http://hg.netbeans.org/main/rev/33e00165e1f4
http://hg.netbeans.org/main/rev/b0028a1d8f90
Comment 8 Jaroslav Tulach 2010-06-04 08:00:53 UTC
No Yxx from me. Just a hint. If you are on a branch and want to create a changeset that contains all your changes then:

$ hg update -C default
$ hg merge your_branch
$ hg branch your_branch
$ hg ci -m "Merge with default"

Then you can send a link to the changeset on hg.netbeans.org, it will contain all your changes done on your_branch.
Comment 9 Martin Entlicher 2010-06-14 15:47:34 UTC
Thanks for the review and for the hint with merging of changesets.
I'll push the change to trunk tomorrow.
Comment 11 Quality Engineering 2010-06-16 03:29:49 UTC
Integrated into 'main-golden', will be available in build *201006160001* on http://bits.netbeans.org/dev/nightly/ (upload may still be in progress)
Changeset: http://hg.netbeans.org/main/rev/5c75009b0619
User: mentlicher@netbeans.org
Log: #186672 Ability to provide custom cell renderers and cell editors - TableRendererModel and TableRendererModelFilter introduced.
Comment 12 rbalada 2010-06-16 08:54:20 UTC
Please verify bugfix for this bug, so it can be included in release691 repository.

Thanks,
-R
Comment 13 Petr Blaha 2010-06-17 11:51:44 UTC
verified
Comment 14 rbalada 2010-06-18 08:06:12 UTC
main #5c75009b0619 transplanted to release691 #f0a674a19832
Comment 15 rbalada 2010-06-22 14:02:43 UTC
Changing status whiteboard to reflect missing changesets.
Comment 16 rbalada 2010-06-22 15:40:55 UTC
I've prepared combined change in branch debugger_ports in release691 repository.
Comment 17 rbalada 2010-06-24 21:55:55 UTC
Integrated in release691 repository

changeset:   171801: release691 #b84021caf081
branch:      debugger_ports
user:        mentlicher@netbeans.org
date:        Tue Jun 08 16:03:09 2010 +0200
summary:     #186672 The Node.Property.canWrite() determines if the cell is editable.

changeset:   171800: release691 #148859144008
branch:      debugger_ports
user:        mentlicher@netbeans.org
date:        Thu Jun 03 13:57:59 2010 +0200
summary:     #186672 - Test the tooltip - the cell renderer's component's tooltip needs to be provided.

changeset:   171799: release691 #10b177525b39
branch:      debugger_ports
user:        mentlicher@netbeans.org
date:        Thu Jun 03 13:55:46 2010 +0200
summary:     #186672 Provide the cell renderer's component's tooltip as a tooltip of the table.

changeset:   171798: release691 #6dd1d7fc1920
branch:      debugger_ports
user:        mentlicher@netbeans.org
date:        Thu Jun 03 09:57:58 2010 +0200
summary:     #186672 - Test added.

changeset:   171797: release691 #1e457fbff93d
branch:      debugger_ports
user:        mentlicher@netbeans.org
date:        Thu Jun 03 09:56:49 2010 +0200
summary:     #186672 - Use the column cell renderer even for the tree column, if defined.

changeset:   171728: release691 #f0a674a19832
user:        mentlicher@netbeans.org
date:        Mon May 31 18:40:32 2010 +0200
summary:     #186672 Ability to provide custom cell renderers and cell editors - TableRendererModel and TableRendererModelFilter introduced.
Comment 18 Quality Engineering 2010-07-22 03:14:54 UTC
Integrated into 'main-golden', will be available in build *201007220001* on http://bits.netbeans.org/dev/nightly/ (upload may still be in progress)
Changeset: http://hg.netbeans.org/main/rev/b0028a1d8f90
User: mentlicher@netbeans.org
Log: #186672 - Test the tooltip - the cell renderer's component's tooltip needs to be provided.


By use of this website, you agree to the NetBeans Policies and Terms of Use. © 2014, Oracle Corporation and/or its affiliates. Sponsored by Oracle logo